USE MemberAdminPL
GO

ALTER VIEW dbo.view_Members_And_MemberTypes
AS
    SELECT  s.SortName,
            p50.PValue                                                                AS TOM,
            p54.PDate                                                                 AS MemberSince,
            CONVERT(tinyint, ISNULL(dbo.fn_sys_GetPropertyValue(s.SId, 52), 0))       AS IsMember
    FROM    dbo.tblStammdaten s INNER JOIN dbo.tblStammProps p50
            ON (s.SId = p50.SId) INNER JOIN dbo.tblStammProps p54
            ON (s.SId = p54.SId)
    WHERE   p50.PId = 50 AND
            p54.PId = 54
GO

-- Security
GRANT SELECT ON dbo.view_Members_And_MemberTypes TO public
GO

-- Kreuztabelle
SELECT  YEAR(MemberSince)                                                           AS Year,
        SUM(CASE WHEN [TOM] = 'Corporate' THEN IsMember ELSE 0 END)    AS C,
        SUM(CASE WHEN [TOM] = 'Individual' THEN IsMember ELSE 0 END)   AS I,
        SUM(CASE WHEN [TOM] = 'Honorary' THEN IsMember ELSE 0 END)     AS H
FROM    dbo.view_Members_And_MemberTypes
GROUP BY
        Year(MemberSince)


-- Auch Kreuztabelle
SELECT  Year(MemberSince), SUM(pvt.Corporate) AS C, SUM(pvt.Individual) AS I, SUM(pvt.Honorary) AS H
FROM    dbo.view_Members_And_MemberTypes
PIVOT   (
            SUM(ISMember)
            FOR TOM IN ([Corporate], [Individual], [Honorary])
        ) AS PVT
GROUP BY
        YEAR(MemberSince)