USE MemberAdminPL
GO

IF EXISTS (SELECT * FROM dbo.sysObjects WHERE name = 'proc_sek1_CreateDynamicPivotTable' AND type = 'P')
    DROP PROC dbo.proc_sek1_CreateDynamicPivotTable
    GO

CREATE PROC dbo.proc_sek1_CreateDynamicPivotTable
AS
    SET NOCOUNT ON

    DECLARE @DynSQL         varchar(4000)
    DECLARE @Year           int
    DECLARE @ColumnName     varchar(100)
    DECLARE @Counter        int
    DECLARE @ReturnValue    int

    -- Existiert die Ausgabetabelle bereits
    IF EXISTS (
                SELECT  *
                FROM    dbo.sysObjects
                WHERE   Id = OBJECT_ID('tmp_DynamicPivotTable', 'U')
              )
    BEGIN
        SET  @DynSQL = 'DROP TABLE tmp_DynamicPivotTable'
        EXEC (@DynSQL)
    END

    -- Erstellen des Grundgersts mittels SQL
    SET @DynSQL = 'CREATE TABLE tmp_DynamicPivotTable([YEAR] int, '

    DECLARE c CURSOR
    FOR
        SELECT  DISTINCT TOM
        FROM    dbo.view_Members_And_MemberTypes

    OPEN c
    FETCH NEXT FROM c INTO @ColumnName
    WHILE (@@FETCH_STATUS <> -1)
    BEGIN
        SET @DynSQL = @DynSQL + @ColumnName + ' int DEFAULT (0),'
        FETCH NEXT FROM c INTO @ColumnName
    END

    CLOSE c
    DEALLOCATE c

    -- Entfernen des letzten Fieldseparators
    SET @DynSQL = LEFT(@DynSQL, LEN(@DynSQL) - 1)
    SET @DynSQL = @DynSQL + ')'

    -- Anlegen der Tabelle
    EXEC (@DynSQL)

    -- Befllen der Tabelle
    EXEC ('INSERT INTO tmp_DynamicPivotTable ([YEAR]) SELECT DISTINCT YEAR(MemberSince) FROM dbo.view_Members_And_MemberTypes')

    DECLARE c CURSOR FOR
    SELECT  YEAR(MemberSince),
            TOM,
            SUM(IsMember)       AS Members
    FROM    dbo.view_Members_And_MemberTypes
    GROUP BY
            YEAR(MemberSince),
            TOM

    OPEN c

    FETCH NEXT FROM c INTO @Year, @ColumnName, @Counter
    WHILE (@@FETCH_STATUS <> -1)
    BEGIN
        SET @DynSQL = 'UPDATE tmp_DynamicPivotTable SET ' + @ColumnName + ' = ' + CONVERT(varchar, @Counter) + ' WHERE [YEAR] = ' + CONVERT(varchar, @Year)
        EXEC  (@DynSQL)
        FETCH NEXT FROM c INTO @Year, @ColumnName, @Counter
    END

    CLOSE c
    DEALLOCATE c

    SET     @ReturnValue = 1

    RETURN ISNULL(@ReturnValue, 0)
    SET NOCOUNT OFF
GO

-- Test
DECLARE @ReturnValue int
EXEC    @ReturnValue = dbo.proc_sek1_CreateDynamicPivotTable
SELECT  @ReturnValue