USE MemberAdminPL
GO

DROP TABLE dbo.DetailTable
DROP TABLE dbo.MainTable

CREATE TABLE dbo.MainTable
(
    Id      int NOT NULL    IDENTITY (1, 10) PRIMARY KEY,
    MyText  varchar(10)
)
GO

CREATE TABLE dbo.DetailTable
(
    Id          int             NOT NULL    IDENTITY (1, 1),
    MasterId    int             NOT NULL    REFERENCES dbo.MainTable (Id) ON DELETE CASCADE,
    MoreMyText  varchar(255)    NOT NULL,

    CONSTRAINT pk_DetailTable PRIMARY KEY
    (Id, MasterId)
)
GO

-- Trigger
CREATE TRIGGER dbo.trg_MainTable_Insert
ON dbo.MainTable
FOR INSERT
NOT FOR REPLICATION
AS
    SET NOCOUNT ON

    INSERT INTO dbo.DetailTable
    (MasterId, MoreMyText)
    SELECT  i.Id, i.MyText
    FROM    inserted i

    SET NOCOUNT OFF
GO